// Networked Systems (H) - Formative Exercise 3
// Worked Answer
//
// Copyright (c) 2012-2018 University of Glasgow
// All rights reserved.

#include <stdio.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <unistd.h>
#include <errno.h>

#define BUFLEN 1500

int 
main(void)
{
  char                buffer[BUFLEN];
  int                 buflen = BUFLEN;
  struct sockaddr_in  loc_addr;
  struct sockaddr     rem_addr;
  socklen_t           rem_addr_len = sizeof(struct sockaddr);
  int                 rlen;

  // Create a UDP/IP socket
  int fd = socket(AF_INET, SOCK_DGRAM, 0);
  if (fd == -1) {
    perror("Unable to create socket");
    return 1;
  }

  // Bind to port 5008
  loc_addr.sin_family      = AF_INET;
  loc_addr.sin_port        = htons(5008);
  loc_addr.sin_addr.s_addr = INADDR_ANY;

  if (bind(fd, (struct sockaddr *) &loc_addr, sizeof(loc_addr)) == -1) {
    perror("Unable to bind to port");
    return 1;
  }

  // Receive a datagram
  if ((rlen = recvfrom(fd, buffer, buflen, 0, &rem_addr, &rem_addr_len)) < 0) {
    perror("Unable to recvfrom() socket");
    return 1;
  }

  // Print the source address:
  char name[BUFLEN];
  if (rem_addr.sa_family == AF_INET) {
    if (inet_ntop(AF_INET, &((struct sockaddr_in *) &rem_addr)->sin_addr, name, BUFLEN) == 0) {
      perror("cannot convert address");
    }
  } else if (rem_addr.sa_family == AF_INET6) {
    if (inet_ntop(AF_INET6, &((struct sockaddr_in6 *) &rem_addr)->sin6_addr, name, BUFLEN) == 0) {
      perror("cannot convert address");
    }
  } else {
    printf("unknown address family %d\n", rem_addr.sa_family);
  }
  printf("remote addr: %s\n", name);
  
  // Print the contents of the datagram
  for (int i = 0; i < rlen; i++) {
    printf("%c", buffer[i]);
  }
  printf("\n");

  // Close the socket and exit
  close(fd);
  return 0;   
}

// vim: set ts=2 tw=0 ai et:
